import * as tslib_1 from "tslib";
import FormControlLabel from '@material-ui/core/FormControlLabel/FormControlLabel';
import Typography from '@material-ui/core/Typography/Typography';
import FieldCoreBase from '@react-form-fields/core/components/FieldCoreBase';
import ValidationContextRegister from '@react-form-fields/core/components/ValidationContextRegister';
import * as React from 'react';
import { getConfig } from '../../config';
import { WithStyles } from '../../decorators/withStyles';
let FieldSelectionBase = class FieldSelectionBase extends FieldCoreBase {
    constructor() {
        super(...arguments);
        this.onChange = (event) => {
            let value = this.props.value;
            if ((event || {}).target && event.target.type === 'checkbox') {
                value = this.props.value ?
                    (event.target.checked ? this.props.value : null) :
                    event.target.checked;
            }
            getConfig().validationOn === 'onChange' && this.setState({ showError: true });
            this.props.onChange(value, event);
        };
        this.onBlur = () => {
            getConfig().validationOn === 'onBlur' && this.setState({ showError: true });
        };
    }
    get labelClassName() {
        const { helperText, disableLabelMargin, classes, FormControlLabelProps } = this.props;
        return (helperText && !disableLabelMargin ? classes.labelAlign : '') + ' ' +
            (FormControlLabelProps && FormControlLabelProps.labelPlacement === 'start' ? classes.labelRight : '');
    }
    get helperTextClassName() {
        const { FormControlLabelProps, classes } = this.props;
        return classes.helperText + ' ' +
            (FormControlLabelProps && FormControlLabelProps.labelPlacement === 'start' ? classes.labelRight : '');
    }
    render() {
        const { value, label, checked, helperText, classes, disabled, Component, FormControlLabelProps, ...props } = this.props;
        return (React.createElement(React.Fragment, null,
            React.createElement(ValidationContextRegister, { field: this }),
            React.createElement(FormControlLabel, Object.assign({}, (FormControlLabelProps || {}), { className: helperText ? classes.containerAlign : null, control: checked ? //force recreation
                    React.createElement(Component, Object.assign({}, props, { checked: true, disabled: disabled, onChange: this.onChange, onBlur: this.onBlur, value: (value || '').toString() })) :
                    React.createElement(Component, Object.assign({}, props, { checked: false, disabled: disabled, onChange: this.onChange, onBlur: this.onBlur, value: (value || '').toString() })), label: React.createElement(React.Fragment, null,
                    !!label &&
                        React.createElement(React.Fragment, null,
                            React.createElement(Typography, { className: this.labelClassName }, label),
                            !!helperText &&
                                React.createElement(Typography, { className: this.helperTextClassName }, helperText)),
                    this.props.children) }))));
    }
};
FieldSelectionBase = tslib_1.__decorate([
    WithStyles({
        containerAlign: {
            alignItems: 'flex-start'
        },
        labelAlign: {
            marginTop: 14
        },
        labelRight: {
            textAlign: 'right'
        },
        helperText: {
            opacity: 0.7,
            fontSize: '95%'
        }
    })
], FieldSelectionBase);
export default FieldSelectionBase;
//# sourceMappingURL=SelectionBase.js.map