import Chip from '@material-ui/core/Chip';
import MenuItem from '@material-ui/core/MenuItem';
import Paper from '@material-ui/core/Paper';
import withStyles from '@material-ui/core/styles/withStyles';
import TextField from '@material-ui/core/TextField';
import Typography from '@material-ui/core/Typography';
import CancelIcon from '@material-ui/icons/Cancel';
import classNames from 'classnames';
import * as React from 'react';
function NoOptionsMessage(props) {
    return (React.createElement(Typography, Object.assign({ color: 'textSecondary', className: props.selectProps.classes.noOptionsMessage }, props.innerProps), props.children));
}
function inputComponent({ inputRef, ...props }) {
    return React.createElement("div", Object.assign({ ref: inputRef }, props));
}
function Control(props) {
    return (React.createElement(TextField, Object.assign({ fullWidth: true, InputProps: {
            inputComponent,
            inputProps: {
                className: props.selectProps.classes.input,
                inputRef: props.innerRef,
                children: props.children,
                ...props.innerProps,
            },
        } }, props.selectProps.textFieldProps)));
}
function Option(props) {
    return (React.createElement(MenuItem, Object.assign({ buttonRef: props.innerRef, selected: props.isFocused, component: 'div', style: {
            fontWeight: props.isSelected ? 500 : 400,
        } }, props.innerProps), props.children));
}
function Placeholder(props) {
    return (React.createElement(Typography, Object.assign({ color: 'textSecondary', className: props.selectProps.classes.placeholder }, props.innerProps), props.children));
}
function SingleValue(props) {
    return (React.createElement(Typography, Object.assign({ className: `${props.selectProps.classes.singleValue} ${props.classes.text}` }, props.innerProps), props.children));
}
function ValueContainer(props) {
    return React.createElement("div", { className: props.selectProps.classes.valueContainer }, props.children);
}
function MultiValue(props) {
    return (React.createElement(Chip, { tabIndex: -1, label: props.children, className: classNames(props.selectProps.classes.chip, {
            [props.selectProps.classes.chipFocused]: props.isFocused,
        }), onDelete: props.removeProps.onClick, deleteIcon: React.createElement(CancelIcon, Object.assign({}, props.removeProps)) }));
}
function Menu(props) {
    return (React.createElement(Paper, Object.assign({ square: true, className: props.selectProps.classes.paper }, props.innerProps), props.children));
}
const components = {
    Control,
    Menu,
    MultiValue,
    NoOptionsMessage,
    Option,
    Placeholder,
    SingleValue: withStyles({
        text: {
            maxWidth: 'calc(100% - 10px)',
            overflow: 'hidden',
            whiteSpace: 'nowrap',
            textOverflow: 'ellipsis'
        }
    })(SingleValue),
    ValueContainer,
};
export default components;
//# sourceMappingURL=components.js.map