import * as tslib_1 from "tslib";
import FormControl from '@material-ui/core/FormControl';
import FieldCoreBase from '@react-form-fields/core/components/FieldCoreBase';
import ValidationContextRegister from '@react-form-fields/core/components/ValidationContextRegister';
import * as React from 'react';
import Select from 'react-select';
import { WithStyles } from '../../decorators/withStyles';
import components from './components';
import styles from './styles';
let FieldAutocomplete = class FieldAutocomplete extends FieldCoreBase {
    constructor() {
        super(...arguments);
        this.styles = {
            input: base => ({
                ...base,
                color: this.props.theme.palette.text.primary,
                '& input': { font: 'inherit', },
            }),
            menuPortal: base => ({ ...base, zIndex: 9999 })
        };
        this.onChange = (value) => {
            this.setState({ showError: true });
            if (!value)
                return this.props.onChange(null);
            this.props.onChange(Array.isArray(value) ? value.map(o => o.value) : value.value);
        };
        this.onFocus = (e) => {
            this.setState({ focused: true });
            this.props.onFocus && this.props.onFocus(e);
        };
        this.onBlur = (e) => {
            this.setState({ focused: false });
            this.props.onBlur && this.props.onBlur(e);
        };
    }
    get value() {
        const value = this.props.value;
        return Array.isArray(value) ? this.props.options.filter(o => value.some(v => o.value == v)) : this.props.options.find(o => value === o.value);
    }
    render() {
        const { focused } = this.state;
        const { classes, theme, options, value, label, onChange, helperText, disabled, placeholder, TextFieldProps, ...extraProps } = this.props;
        return (React.createElement("div", { className: classes.root },
            React.createElement(ValidationContextRegister, { field: this }),
            React.createElement(FormControl, { margin: extraProps.margin || 'normal', fullWidth: true, error: !!this.errorMessage, variant: extraProps.variant },
                React.createElement(Select, Object.assign({ classes: classes, styles: this.styles, menuPortalTarget: document.body }, extraProps, { textFieldProps: {
                        label,
                        InputLabelProps: { shrink: true },
                        ...(TextFieldProps || {}),
                        error: !!this.errorMessage,
                        helperText: this.errorMessage || helperText,
                    }, isDisabled: disabled, options: options, components: components, value: this.value || null, onFocus: this.onFocus, onBlur: this.onBlur, onChange: this.onChange, placeholder: focused ? null : placeholder })))));
    }
};
FieldAutocomplete = tslib_1.__decorate([
    WithStyles(styles, { withTheme: true })
], FieldAutocomplete);
export default FieldAutocomplete;
//# sourceMappingURL=index.js.map