import TextField from '@material-ui/core/TextField/TextField';
import ColorIndicator from '@material-ui/icons/Stop';
import FieldCoreBase from '@react-form-fields/core/components/FieldCoreBase';
import ValidationContextRegister from '@react-form-fields/core/components/ValidationContextRegister';
import * as React from 'react';
import { getConfig } from '../../config';
import PickerDialog from './PickerDialog';
export default class FieldColor extends FieldCoreBase {
    constructor(props) {
        super(props);
        this.showPicker = () => this.setState({ showPicker: true });
        this.hidePicker = () => this.setState({ showPicker: false });
        this.onChange = (event) => {
            getConfig().validationOn === 'onChange' && this.setState({ showError: true });
            this.props.onChange(event.hex);
        };
        this.onBlur = (e) => {
            this.props.onBlur && this.props.onBlur(e);
            getConfig().validationOn === 'onBlur' && this.setState({ showError: true });
        };
        this.state = { ...this.state, showPicker: false };
    }
    render() {
        const { showPicker } = this.state;
        const { value, helperText, multiline, validationContext, InputProps, ...extraProps } = this.props;
        return (React.createElement(React.Fragment, null,
            React.createElement(ValidationContextRegister, { field: this }),
            React.createElement(TextField, Object.assign({}, {
                fullWidth: true,
                margin: 'normal',
                ...(extraProps),
                required: this.isRequired,
                value: (value === undefined || value === null ? '' : value).toString(),
                error: !!this.errorMessage,
                helperText: this.errorMessage || helperText,
                onChange: this.onChange,
                onBlur: this.onBlur,
                submitted: null,
                touched: null,
                loading: null
            }, { onClick: this.showPicker, InputProps: {
                    startAdornment: React.createElement(ColorIndicator, { color: 'inherit', style: { color: value } }),
                    ...(InputProps || {})
                } })),
            showPicker && (React.createElement(PickerDialog, { value: value || '', onDismiss: this.hidePicker, onChange: this.onChange }))));
    }
}
//# sourceMappingURL=index.js.map