import DateUtils from '@date-io/date-fns';
import { setConfig } from '@react-form-fields/core/config';
import MuiPickersUtilsProvider from 'material-ui-pickers/MuiPickersUtilsProvider';
import * as React from 'react';
import { getConfig } from '../config';
export default class FormFieldsContext extends React.PureComponent {
    constructor(props) {
        super(props);
        setConfig(this.props.config);
    }
    componentDidUpdate(prevProps) {
        if (!this.props.config || prevProps.config === this.props.config)
            return;
        setConfig(this.props.config);
    }
    render() {
        return (React.createElement(MuiPickersUtilsProvider, { utils: DateUtils, locale: getConfig().dateLocale }, this.props.children));
    }
}
//# sourceMappingURL=Context.js.map