import ChevronLeftIcon from '@material-ui/icons/ChevronLeft';
import ChevronRightIcon from '@material-ui/icons/ChevronRight';
import FieldCoreBase from '@react-form-fields/core/components/FieldCoreBase';
import ValidationContextRegister from '@react-form-fields/core/components/ValidationContextRegister';
import dateFnsFormat from 'date-fns/format';
import dateFnsParse from 'date-fns/parse';
import DatePicker from 'material-ui-pickers/DatePicker';
import * as React from 'react';
import { getConfig } from '../config';
export default class FieldDate extends FieldCoreBase {
    constructor() {
        super(...arguments);
        this.removeTime = (date) => {
            if (!date || this.props.keepTime)
                return date;
            return dateFnsParse(dateFnsFormat(date, 'yyyy-MM-dd'), 'yyyy-MM-dd', new Date(), {
                locale: getConfig().dateLocale
            });
        };
        this.onChange = (date) => {
            getConfig().validationOn === 'onChange' && this.setState({ showError: true });
            this.props.onChange(this.removeTime(date));
        };
        this.onBlur = (e) => {
            this.props.onBlur && this.props.onBlur(e);
            getConfig().validationOn === 'onBlur' && this.setState({ showError: true });
        };
    }
    render() {
        const { value, label, format, helperText, validation, validationContext, onBlur, mask, ...extraProps } = this.props;
        return (React.createElement(React.Fragment, null,
            React.createElement(ValidationContextRegister, { field: this }),
            React.createElement(DatePicker, Object.assign({ clearable: true, clearLabel: getConfig().dateLabels.clear, okLabel: getConfig().dateLabels.ok, cancelLabel: getConfig().dateLabels.cancel, format: format || getConfig().dateFormat, fullWidth: true, margin: 'normal', leftArrowIcon: React.createElement(ChevronLeftIcon, null), rightArrowIcon: React.createElement(ChevronRightIcon, null) }, extraProps, { label: label, value: value || null, error: !!this.errorMessage, helperText: this.errorMessage || helperText, required: this.isRequired, onChange: this.onChange, onBlur: this.onBlur }))));
    }
}
//# sourceMappingURL=Date.js.map