import ValidationContext from '@react-form-fields/core/components/ValidationContext';
import * as React from 'react';
export default class FormValidation extends React.PureComponent {
    constructor() {
        super(...arguments);
        this.bindValidationContext = (validationContext) => {
            this.validationContext = validationContext;
        };
        this.onSubmit = (e) => {
            e && e.preventDefault && e.preventDefault();
            e && e.stopPropagation && e.stopPropagation();
            const isValid = this.validationContext.isValid(true);
            this.props.onSubmit(isValid);
        };
        this.isValid = (formSubmitted = true) => {
            return this.validationContext.isValid(formSubmitted);
        };
        this.reset = () => {
            this.validationContext.reset();
        };
    }
    render() {
        return (React.createElement("form", { noValidate: true, onSubmit: this.onSubmit },
            React.createElement(ValidationContext, { ref: this.bindValidationContext }, this.props.children)));
    }
}
//# sourceMappingURL=FormValidation.js.map