import FieldCoreBase from '@react-form-fields/core/components/FieldCoreBase';
import ValidationContextRegister from '@react-form-fields/core/components/ValidationContextRegister';
import TimePicker from 'material-ui-pickers/TimePicker';
import * as React from 'react';
import { getConfig } from '../config';
export default class FieldTime extends FieldCoreBase {
    constructor() {
        super(...arguments);
        this.onChange = (date) => {
            getConfig().validationOn === 'onChange' && this.setState({ showError: true });
            this.props.onChange(date);
        };
        this.onBlur = (e) => {
            this.props.onBlur && this.props.onBlur(e);
            getConfig().validationOn === 'onBlur' && this.setState({ showError: true });
        };
    }
    render() {
        const { value, label, format, helperText, validation, validationContext, onBlur, mask, ...extraProps } = this.props;
        return (React.createElement(React.Fragment, null,
            React.createElement(ValidationContextRegister, { field: this }),
            React.createElement(TimePicker, Object.assign({ clearable: true, clearLabel: getConfig().dateLabels.clear, okLabel: getConfig().dateLabels.ok, cancelLabel: getConfig().dateLabels.cancel, format: format || getConfig().timeFormat, fullWidth: true, margin: 'normal' }, extraProps, { label: label, value: value || null, error: !!this.errorMessage, helperText: this.errorMessage || helperText, required: this.isRequired, onChange: this.onChange, onBlur: this.onBlur }))));
    }
}
//# sourceMappingURL=Time.js.map