import CoreConfigBuilder from '@react-form-fields/core/config/builder';
export default class ConfigBuilder extends CoreConfigBuilder {
    setDateConfig(locale, format, labels) {
        this.config = {
            ...this.config,
            dateLocale: locale,
            dateFormat: format,
            dateLabels: labels
        };
        return this;
    }
    setTrumbowygLocale(loadLocale) {
        const currentConfig = this.config.trumbowyg || {};
        this.config = {
            ...this.config,
            trumbowyg: { ...currentConfig, loadLocale }
        };
        return this;
    }
    setTrumbowygPlugins(loadPlugins) {
        const currentConfig = this.config.trumbowyg || {};
        this.config = {
            ...this.config,
            trumbowyg: { ...currentConfig, loadPlugins }
        };
        return this;
    }
    setTrumbowygConfig(config, resetConfig = false) {
        const currentConfig = this.config.trumbowyg || {};
        this.config = {
            ...this.config,
            trumbowyg: {
                ...currentConfig,
                config: {
                    ...(resetConfig ? {} : (currentConfig.config || {})),
                    ...config
                }
            }
        };
        return this;
    }
    setValidationOn(event) {
        this.config = {
            ...this.config,
            validationOn: event
        };
        return this;
    }
}
//# sourceMappingURL=builder.js.map